//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  clrOrange
#property indicator_width1  2
#property strict

//
//
//
//
//

enum prices
{
   pr_close,   // Close
   pr_open,    // Open
   pr_high,    // High
   pr_low,     // Low
   pr_median,  // Median
   pr_typical, // Typical
   pr_weighted // Weighted
};
enum mas
{
   ma_sma,   // Simple moving average (SMA)
   ma_ema,   // Exponential moving average (EMA)
   ma_smma,  // Smoothed moving average (SMMA)
   ma_lwma   // Linear weighted moving average (LWMA)
};

extern prices Price    =  PRICE_CLOSE;  // Price to use 
extern mas    MaType   =  ma_ema;       // Average type
extern int    MaLength =  20;           // Average period

double diff[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,diff); SetIndexStyle(0,DRAW_HISTOGRAM);
   IndicatorShortName ("Price to ma difference ("+(string)MaLength+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   //

   for(int i=limit; i >= 0; i--) diff[i] = iMA(NULL,0,1,0,(int)MaType,(int)Price,i)-iMA(NULL,0,MaLength,0,(int)MaType,(int)Price,i);
   return(0);
}